=== plugins/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: Alberto Villa <avilla@FreeBSD.org>

include_directories(${CMAKE_SOURCE_DIR}/src)

add_subdirectory(sampleplugin)
