=== data/effects/ladspa/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: Julius Künzel <jk.kdedev@smartlab.uber.space>

INSTALL (FILES 

ladspa_declipper.xml
ladspa_equalizer.xml
ladspa_equalizer_15.xml
ladspa_librnnoise.xml
ladspa_limiter.xml
ladspa_phaser.xml
ladspa_pitch.xml
ladspa_pitch_scale.xml
ladspa_rate_scale.xml
ladspa_reverb.xml
ladspa_room_reverb.xml
ladspa_vinyl.xml

DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX}/effects)
